#include "allegro.h"
#include <iostream>
#include <aldumb.h>

//add pushable objects
//don't allow people to hang out of portals
//game ending
//max momentum, make so that there will be traps at the location where you would expect someone's momentum to run out &c.
//add pause after finishing level

void init();
void deinit();

int min(int a, int b)
{
	if (a<b) return a;
	else return b;    
}

int max(int a,int b)
{
	if (a>b)  return a;
	else return b;
}
const int pan = 128;
const int pitch = 1000;

//////////////////////////
//
//    
//
//////////////////////////




const int realwidth=640;
const int realheight=480;

const int virtualwidth=160;
const int virtualheight=120;
const int displaywidth=160;
const int displayheight=50;
const int margin=35;
const int bufferheight=displayheight+margin;
const int realmargin=200;
const int realdisplayheight=480;
const int mapwidth=2800;

const int datarow=200;
const int driprow=201;

const int playerwidth=7;
const int playerheight=12;

bool endscreen;

BITMAP *buffer;
BITMAP *bg;
BITMAP *playerbmp;


DUH *music;
AL_DUH_PLAYER *dp;

int curline;
bool spaceoff;

const int waitforline=20;

const int speechcount=10;
struct Event { 
	int x; 
	char* s[speechcount];
};

const int eventcount=15;
const Event events[eventcount] = 
{
	{0,{"I feel thirsty","\n"}},
	{250,{"Ahh...refreshing","\n"}},
	{296,{"My mother awaits me","\n"}},
	{418,{	"Son",
			"I worry for you",
			"May god protect.","\n"}},
	{549,{	"I miss my wife,",
"my children.",
			"I cannot look away",
			"yet must move on.",
			"\n"}
	},
{721,{	
"I will walk proudly",
"to my own death",
"for our glory",
"\n"}
},
{899,{	
"I am a peace envoy",
"I go back and forth",
"all day.",
"Some days",
"I cannot remember",
"what side I am on.",
"\n"}
},
{1075,{	
"I cannot remember",
"what side I am on.",
"No one will notice,",
"so long as",
"I am not given",
"the order to retreat",
"\n"}
},
{1542,{	
"The ash of our fires",
"cloaks the sky.",
"Our strivings",
"will be rewarded.",
"\n"}
},
{1713,{	
"We have incurred",
"terrible losses",
"and inflicted them.",
"\n"}
},
{1902,{	
"You have killed",
"many of my brothers",
"\n"
}},
{1914,{
"How many of my sons",
"have you murdered?",
"\n"}},
{1926,{
"Have you come here",
"to kill me as well?",
"\n"}
},
{2143,{	
"Please!",
"Spare me;",
"I am so old...",
"\n"}
},
{2175,{
"Go to your mother;",
"she must miss you,",
"as I miss my sons.",
"\n"}
}
};

int f=0;
int t=0;

bool visited[eventcount];


int columns[displaywidth];

bool showtitle;

enum ColumnData {cd_none,cd_begin,cd_occ,cd_end,cd_dead};

ColumnData columndata[mapwidth];
bool dripdata[mapwidth];

enum Gamestate {  gs_title, gs_game};
enum Playstate {  ps_walking, ps_talking, ps_dying};

class Player{
public:
	int x;
	Player();
	Playstate state;
	bool dir;
	void draw();
	void move();
	bool alive;
private:
	void moveleft();
	void moveright();
	void checkevents();
	int frame;
	int curevent;
};

Player::Player() : x(displaywidth/2), state(ps_talking), dir(0),  alive(1), frame(0)
{
}

void Player::draw()
{
	if (alive)
	{
		if(x<displaywidth/2)
			masked_blit(playerbmp,buffer,playerwidth*frame,playerheight*dir,x-3,displayheight-playerheight-7,playerwidth,playerheight);
		else
			masked_blit(playerbmp,buffer,playerwidth*frame,playerheight*dir,displaywidth/2-3,displayheight-playerheight-7,playerwidth,playerheight);

		if (state==ps_talking)
		{
			textout_centre_ex(buffer, font, events[curevent].s[curline], displaywidth/2, 5, makecol(255,255,255),makecol(0,0,0));		
		}
	}
	else
	{
		masked_blit(playerbmp,buffer,0,24,displaywidth/2-3,displayheight-playerheight,13,10);
		
	}
}

void Player::checkevents()
{
	for (int i=0;i<eventcount;i++)
	{
		if (events[i].x==x && (!visited[i]))
		{
			state=ps_talking;
			frame=0;
			curevent=i;
			visited[i]=1;
		}
	}
}

void Player::move()
{
	if (state==ps_walking)
	{
		if (key[KEY_LEFT])
		{
			dir=1;
			frame=(frame+1)%7;
			if(x>displaywidth/2)
			{
				x=columns[displaywidth/2-1];
				moveleft();
			}
			else frame=0;

			checkevents();
		}
		else if (key[KEY_RIGHT])
		{
			dir=0;
			frame=(frame+1)%7;
			if(x<mapwidth-displaywidth/2)
			{
				x=columns[displaywidth/2+1];
				moveright();
			}
			else frame=0;
			checkevents();
		}
		else {
			frame=(((frame+2)%7) / 4);
		}
	}
	else if (state==ps_talking)
	{
			if (key[KEY_SPACE])
			{
				if (spaceoff)
				{
					spaceoff=false;
					curline++;
					if (events[curevent].s[curline][0]=='\n')
					{
						if (x==1926)
							for (int i=1927;i<=1937;i++)
							{
								columndata[i]=cd_dead;
								t=0;
							}
						else if (x==2175)
							for (int i=2177;i<=2185;i++)
							{
								columndata[i]=cd_dead;
								t=0;
					
							}
							
						state=ps_walking;
						curline=0;
					}
				}
			}
		else
			spaceoff=true;
	}
	
}


/*
 maybe the other mechanism was more interesting, as it allows you to avoid certain things, and come at things from different angles?
 
 */

//need to make these algorithms better, so the player cann't avoid any obstacles
void Player::moveleft()
{
	//first shift everything to the right
	for (int i=displaywidth-1;i>0;i--)
		columns[i]=columns[i-1];

//	columns[0]=x+displaywidth/2;
	columns[0]++;
	
	if (columndata[columns[0]]==cd_end)
	{
		int i=1;
		while (columndata[columns[i]]!=cd_none)
		{
			if (columndata[columns[i]]==cd_end)
			{
				for (int j=0;j<=i;j++)
					columndata[columns[j]]=cd_dead;
				
				break;
			}
			else if (columndata[columns[i]]==cd_begin)
				break;
			i++;
		}
		
	}
	
}

void Player::moveright()
{
	//first shift everything to the left
	for (int i=0;i<displaywidth-1;i++)
		columns[i]=columns[i+1];
	
//	columns[displaywidth-1]=x+displaywidth/2;
	columns[displaywidth-1]++;

	if (columndata[columns[displaywidth-1]]==cd_end)
	{
		int i=displaywidth-2;
		while (columndata[columns[i]]!=cd_none)
		{
			if (columndata[columns[i]]==cd_end)
			{
				for (int j=displaywidth-1;j>=i;j--)
					columndata[columns[j]]=cd_dead;
				break;
			}
			else if (columndata[columns[i]]==cd_begin)
				break;
			i--;
		}
		
	}
}

Player p;

void initlevel()
{
	endscreen=false;
	curline=0;
	spaceoff=true;
	for (int i=0;i<displaywidth;i++)
		columns[i]=i;
	
	for (int i=0;i<mapwidth;i++)
	{

		if (getpixel(bg, i, datarow)==makecol(0,0,0))
		{
			columndata[i]=cd_occ;
		}
		else if (getpixel(bg, i, datarow)==makecol(255,0,0))
		{
			columndata[i]=cd_begin;
		}
		else if (getpixel(bg, i, datarow)==makecol(0,255,0))
		{
			columndata[i]=cd_end;
		}
		else
			columndata[i]=cd_none;
		
		if (getpixel(bg,i,driprow)==makecol(0,0,255))
		{
			dripdata[i]=true;
		}
		else
			dripdata[i]=false;
	}
}

void drawscreen()
{
	for (int i=0;i<displaywidth;i++)
	{
		switch (columndata[columns[i]])
		{
			case cd_dead:
				blit(bg,buffer,columns[i],displayheight*3,i,0,displaywidth,displayheight);
				if (dripdata[columns[i]])
				{
					int g=t%(margin*2);
					if (g<margin)
					{
						putpixel(buffer,i,displayheight+g,makecol(211,32,39));
					}
				}
				break;
			case cd_begin:
			case cd_occ:
			case cd_end:
				blit(bg,buffer,columns[i],displayheight*f,i,0,displaywidth,displayheight);	
				break;
			default:
				blit(bg,buffer,columns[i],0,i,0,displaywidth,displayheight);
				break;
		}

	}
}

volatile unsigned int frames, fps;
void second_counter(void)
{
	fps=frames;
	frames=0;
} END_OF_FUNCTION(second_counter);
int timewaster_delay;
extern void do_prog(void);

volatile unsigned int ticks;
void ticker(void)
{
	++ticks;
} END_OF_FUNCTION(ticker);


int main() {
    
	
	init();
	clear_to_color(screen,makecol(0,0,0));    

	
	while (!key[KEY_ESC]) {
		clear_to_color(buffer,makecol(0,0,0));    

		if (showtitle)
		{
			textout_centre_ex(buffer, font,"defect", displaywidth/2, 5, makecol(255,255,255),makecol(0,0,0));		
			textout_centre_ex(buffer, font,"by", displaywidth/2, 5+15, makecol(255,255,255),makecol(0,0,0));		
			textout_centre_ex(buffer, font,"increpare", displaywidth/2, 5+30, makecol(255,255,255),makecol(0,0,0));		
			if (key[KEY_SPACE])
			{
				showtitle=false;
				spaceoff=false;
			}
		}
		else
		{
			al_poll_duh(dp);

			t++;
			if (t%10==0)
				f=(f+1)%3;
			
			if (!endscreen)
				p.move();

			if (p.x==2687)
			{
				if (columndata[432]==cd_dead)
				{
					p.alive=false;
				}
				else
				{
					endscreen=true;
				}
			}
			
			drawscreen();
			
			p.draw();
				
			if (endscreen)
			{
				textout_centre_ex(buffer, font, "END", virtualwidth/2, 5, makecol(255,255,255), makecol(0,0,0));
			}

			/* control timing */
			while (ticks<1)
			{
				rest(0);
			}
			ticks=0;
			++frames;
		}
		
		stretch_blit(buffer,screen,0,0,displaywidth,bufferheight,0,100,realwidth,realheight-100);
//		blit(buffer,screen,0,0,0,0,640,480);
	}
	
	
	deinit();
	return 0;
}
END_OF_MAIN()

void init() {
	showtitle=true;
	
	int depth, res;
	allegro_init();
    atexit(&dumb_exit);
	
	
	
	depth = desktop_color_depth();
	if (depth == 0) depth = 32;
	set_color_depth(depth);
	res = set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0);
	if (res != 0) {
		allegro_message(allegro_error);
		exit(-1);
	}
	
	install_timer();
	install_keyboard();
	install_mouse();
	
	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
		allegro_message("Error initialising sound system\n%s\n", allegro_error);
	}
	
	dumb_register_stdfiles();

	
    music = dumb_load_xm_quick("bgmusic.xm");
	dp=al_start_duh(music,1,0,1.0f, 4096,11025);	
	            
	
	LOCK_FUNCTION(second_counter);
	LOCK_VARIABLE(fps);
	LOCK_VARIABLE(frames);
	LOCK_FUNCTION(ticker);
	LOCK_VARIABLE(ticks);
	
	
	frames=timewaster_delay=0;
	install_int_ex(second_counter, BPS_TO_TIMER(1));
	install_int_ex(ticker, BPS_TO_TIMER(10));
	
	
	buffer=create_bitmap(displaywidth,bufferheight);
	bg=load_bitmap("backdrop.bmp",NULL);
	playerbmp=load_bitmap("player.bmp",NULL);
	
	initlevel();
}

void deinit() {
	clear_keybuf();
	/* add other deinitializations here */
}
